#include "lpc2388.h"

#define LED1 0x00040000	/* bit18 */

int main()
{
	int on;	/* LED の状態 */
	int data;

		/* PINコンフィグレーション */
	PINSEL0 = 0x50;			/* RD0, TD0 をアサイン */

		/* IOピンをファストIOにする */
	SCS |= 1;

		/* LED1に接続されたピンを出力にする */
	FIO1DIR |= LED1;

		/* LED1を消す */
	FIO1SET  = LED1;	/* H出力（LED1消灯） */

		/* UART 0 初期化 */
	U0LCR = 0x80;		/* DLL,DLMへのアクセスモードに変更 */
	U0DLL = 26;			/* クロックは4MHzを仮定。デフォルトでUARTのPCLK = SYSCLK/4 */
	U0DLM = 0;			/* 4000000/4/(16*26) = 2400[baud] */
	U0LCR = 0x07;		/* 2 stop bit, non parity, 8bit word, DLL,DLM はアクセス不能 */


	on = 0;

	while (1)
	{
		while ( !( U0LSR & 0x01) )		/* b0 は RDR(Receive Data Ready )*/
			;
		data = U0RBR;					/* データを空読み */
		U0THR = data;

		if (on)
			FIO1SET  = LED1;	/* H出力（LED1消灯） */
		else
			FIO1CLR  = LED1;	/* L出力（LED1点灯） */
		on ^= 1;	/*LED状態を反転*/
	}

	return 0;
}
