
/*
 *    スタートアップモジュール(ARMv4用)
 */




        .text
        .code 32
        .align     4
        .global    start
        .global	irq_entry
start:
//      mov  r1,  #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT) /* To System mode */
		mov  r1,  #0x00D3		/* IRQ disable, FIQ disable, SVR mode */
		msr  cpsr, r1

        /*
         * スタックポインタと，フレームポインタの初期化
         */
        ldr  r3, =0x4000FFFC	/* スタック = SRAMのトップ */
        mov  sp, r3
        mov  r11, #0        /* Armモード用フレームポインタ   */



        /*
         *  bssセクションのクリア
         */
start_1:
        ldr  r1, =__bss_start
        ldr  r2, =__bss_end
        cmp  r1,r2
        bhs  start_6
        mov  r0,#0
start_2:
        str  r0,[r1],#4
        cmp  r1, r2
        blo  start_2


	/* メイン関数の呼び出し */
start_6:
        bl    main

	/*
	* エンドレス・ループ
	*/
start_7:
	b   start_7


irq_entry:

         /*
         *  復帰処理
         *  割り込み許可となるがタスクコンテキスト上に保存しているため，
         *  問題はない
         */

        ldmfd   sp!,{r0-r3,ip,lr,pc}^ /*タスク復帰 + 割込み許可 */

