/*
 * vector.S
 *
 *  Created on: 2009/09/03
 *      Author: suikan
 */
/*
 *    スタートアップモジュール(ARMv4用)
 */


        /*
         * Vectorテーブルとジャンプテーブル
         * サイズは合計0x3c
         */
        .section .vector,"a"
        .code 32
        .align 4
        .global vector_table
vector_table:
        ldr pc, reset_vector       /* リセット             */
        ldr pc, undef_vector       /* 未定義命令           */
        ldr pc, swi_vector         /* ソフトウェア割込み   */
        ldr pc, prefech_vector     /* プリフェッチアボード */
        ldr pc, data_abort_vector  /* データアボード       */
        ldr pc, reset_vector
        ldr pc, irq_vector         /* IRQ                  */
        ldr pc, fiq_vector         /* IRQ                  */

/*
 *  ベクターテーブル
 */
reset_vector:
        .long   start
undef_vector:
        .long   undef_exception
swi_vector:
        .long   swi_exception
prefech_vector:
        .long   prefetch_exception
data_abort_vector:
        .long   data_abort_exception
irq_vector:
        .long   irq_exception
fiq_vector:
        .long   fiq_exception


		.text
        .code 32
        .align 4
irq_exception:
        /*
         * 割込みモード
         *
         * cpsrがspsr_irqに復帰先がr14_irq(lp)に入り，
         * spsr_irqとr14_irqとr13(sp)_irqが r14,r13となる．
         */

        stmfd   sp!, {r0-r3,ip,lr,pc} /* pcはダミー */
        ldr r0,=irq_entry
		mov pc,r0

reset_exception:
undef_exception:
swi_exception:
prefetch_exception:
data_abort_exception:
reserved_exception:
fiq_exception:
		b fiq_exception

